analysis::genUmgebung :=
proc(stelle, epsilon, options = null())
  local rechts, links, temp;
begin
  epsilon := float(analysis::deEqualize(epsilon));
  stelle := float(analysis::deEqualize(stelle));

  if has( map([epsilon, stelle], testtype, Type::Numeric), FALSE ) then
    error("Die ersten beiden Parameter muessen numerische Werte sein");
  end:

  links  := float(stelle-epsilon);
  rechts := float(stelle+epsilon);

  temp := plot::PointList2d([[links, 1], [rechts, -1]],
                            hold(Color) =
                            plot::getDefault(plot::Scene2d::BackgroundColor));
  if options = null() then
    options := hold(Color) = RGB::Red;
  end_if:

  return(plot::Group2d(temp,
                       plot::Line2d([links, -.25], [links, .25], options),
                       plot::Line2d([rechts, -.25], [rechts, .25], options)
                       )
         );
end;
