alias ( zusFunktion = analysis::zusFunktion ):
alias ( Funktion = analysis::Funktion ):
alias ( Folge = analysis::Folge ):
alias ( FunkTerm(f) = op(f,1) ):
alias ( FunkVar(f)  = op(f,2) ):
alias ( zuFolgen(f) = analysis::zuFolgen(f) ):
alias ( zuFunktionen(f) = analysis::zuFunktionen(f) ):
alias ( genGerade = analysis::gerade ):
alias ( genTangente = analysis::tangente ):
alias ( genLinie = analysis::genLinie ):

analysis::graphBisektion :=
proc(f, bereich, genau = _power(10.0, -DIGITS))
  local j, b, i, theLines;
begin
  if args(0) < 2 then
    error("Erwarte mindestens 2 Parameter");
  end:

  f := op(zuFunktionen(f));
  
  if nops([f]) <> 1 or f = FAIL then
    error("Erwarte eine Funktion als 1. Parameter");
  end;

  bereich := analysis::deEqualize(bereich);
  genau   := float(analysis::deEqualize(genau));
        
  if type(bereich) <> "_range" then
    error("Erwarte eine Gleichung als 2. Parameter");
  end:
  
  if type(genau) <> DOM_FLOAT then
    error("Erwarte eine Gleitkommazahl als 4. Parameter");
  end:

  b := analysis::nsBisektion(f, bereich, genau);
  theLines := [];
  
  j := 0;

  for i in b do
    j := j + 1;
    theLines := append(theLines,
                       plot::Line2d([op(i, 1), j],
                                    [op(i, 2), j],
                                    hold(Color) = analysis::_GRAPHFARBE,
                                    hold(LineWidth) = analysis::_DICKE
                                    )
                       );
        end;

  b := float(op(b[nops(b)], 1));
  
  return( plot::Group2d( op(theLines) ) ):
end;

