// Markus Thewes
// ueberarbeitet: frankp, 20.03.2000

alias( ispoly = analysis::istPolynom ):

/*------------------------------------------------------------------------------
    linear(f,x)

    f: arithm. Ausdruck
    x: DOM_IDENT

    Liefert TRUE, wenn f linear in x ist.
------------------------------------------------------------------------------*/
analysis::linear := proc(ex,x)
begin
    if ispoly(ex,x) and degree(poly(ex,[x])) < 2 then 
        return(TRUE)
    else
        return(FALSE)
    end_if
end_proc:

/*------------------------------------------------------------------------------
    partialbruchzerlegung(f,x)

    f: arithm. Ausdruck
    x: DOM_IDENT

    Fuehrt die Partialbruchzerlegung von f durch und liefert
    den nicht-echt-gebrochenen Anteil, den echt-gebrochener Anteil und die 
    Partialbrueche von f.
------------------------------------------------------------------------------*/
analysis::partialbruchzerlegung := proc(ex,x)
    local ganzrational,partialbruch,zaehler,nenner,echtgebrochen;
begin
    zaehler := numer(ex);
    nenner := denom(ex);

    ex := partfrac(ex,x);

    ganzrational := divide(zaehler, nenner,[x], Quo);
    echtgebrochen := divide(zaehler, nenner,[x], Rem);

    partialbruch := ex-ganzrational;
    return([ganzrational,partialbruch,echtgebrochen/nenner])
end_proc:

