analysis::genRichtungsfeld  := proc (f, Xbereich, Ybereich, farbe = (hold(Farbe) = analysis::_RICHTUNGSFELDFARBE))
    local bereiche, xschritt, yschritt, p1x,p1y, p2x, p2y, lines, i, j, steigung, lambda;
    begin
        if args(0) < 3 then
            error("Erwarte mindestens 3 Parameter");
        end:

        f := op(analysis::zuFunktionen(f));
    
        if domtype(f) <> analysis::Funktion or nops(indets(f) minus {PI, op(f,2)}) > 0 then
            error("Funktionsterm besteht aus zu vielen Unbestimmten");
        end:

        if testtype(farbe, Type::Equation(DOM_IDENT, Type::ListOf(Type::Numeric, 3,3))) then
            if op(farbe, 1) = hold(Farbe) then
                farbe := analysis::deEqualize(farbe);
            else
                error("Erwarte Farbe (Liste von RGB Werten) im 4. Parameter");
            end:
        else
            error("Erwarte Farbe (Liste von RGB Werten) im 4. Parameter");
        end:
        
        bereiche := map([Xbereich, Ybereich], analysis::deEqualize);
        
        Xbereich := bereiche[1];
        Ybereich := bereiche[2];

        if testtype( Xbereich, Type::ListProduct( "_range", Type::Numeric ) ) then
            xschritt := op(Xbereich, 2);
            Xbereich := op(Xbereich, 1);
        elif type( Xbereich ) =  "_range" then
            xschritt := 1;
        else
            error("Ungueltiger Bereich")
        end:

        if testtype( Ybereich, Type::ListProduct( "_range", Type::Numeric ) ) then
            yschritt := op(Ybereich, 2);
            Ybereich := op(Ybereich, 1);
        elif type( Ybereich ) =  "_range" then
            yschritt := 1;
        else
            error("Ungueltige Bereichsangabe im 2. Parameter")
        end:


        lines := [];    

        for i from float(op(Xbereich, 1)) to float(op(Xbereich, 2)) step float(xschritt) do
        for j from float(op(Ybereich, 1)) to float(op(Ybereich, 2)) step float(yschritt) do
                //i := k + 1/2 * schrittweite * 1.0;
                if traperror(f(i)) = 0 then
                    steigung := float(f(i));
                else
                    while traperror(f(i)) <> 0 do
                        i := i + _power(10, -DIGITS);
                    end_while;
                    steigung := float(f(i));
                end:
                if float(steigung) = 0.0 then
                    p1x := i + xschritt * 0.5;
                    p2x := i - xschritt * 0.5;
                    p1y := j;
                    p2y := p1y;
                else //steigung > 0 then
                    lambda := 1/steigung;
                    if abs(lambda) > 1 then
                        p1x := i + sign(lambda) * xschritt * 0.5;
                        p2x := i - sign(lambda) * xschritt * 0.5;
                    else
                        p1x := i + lambda * xschritt * 0.5;
                        p2x := i - lambda * xschritt * 0.5;
                    end:

                   p1y := j + (p1x - i) * steigung;
                   p2y := j + (p2x - i) * steigung;
                end:
                p1x := float(p1x);
                p1y := float(p1y);
                p2x := float(p2x);
                p2y := float(p2y);

                                    
                lines := append(lines, analysis::genLinie(point(p1x, p1y), point(p2x, p2y), farbe));
            end:
        end:

        return(op(lines));
    end:

