alias ( zusFunktion = analysis::zusFunktion ):
alias ( Funktion = analysis::Funktion ):
alias ( Folge = analysis::Folge ):
alias ( FunkTerm(f) = op(f,1) ):
alias ( FunkVar(f)  = op(f,2) ):
alias ( zuFolgen(f) = analysis::zuFolgen(f) ):
alias ( zuFunktionen(f) = analysis::zuFunktionen(f) ):
alias ( genGerade = analysis::gerade ):
alias ( genTangente = analysis::tangente ):
alias ( genLinie = analysis::genLinie ):

analysis::graphNewton :=
proc(f, start, ber = FAIL, genau = _power(10.0, -DIGITS))
  local bereich, liste, temp, hilfslinien, tangenten, i;
begin

  if args(0) < 2 then
    error("Erwarte mindestens zwei Parameter")
  end:

  f := op(zuFunktionen(f));

  if nops([f]) <> 1 or f = FAIL then
    error("Erwarte eine Funktion als 1. Parameter");
  end;

  start   := float(analysis::deEqualize(start));
        
  if ber <> FAIL then
    if type((ber := analysis::deEqualize(ber))) <> "_range" then
      error("Erwarte eine Gleichung als 4. Parameter");
    end:
  end:
        
  if domtype(start) <> DOM_FLOAT  then
    error("Erwarte eine Gleitkommazahl als 2. Parameter");
  end:
        
  if domtype(genau) <> DOM_FLOAT then
    error("Erwarte eine Gleitkommazahl als 4. Parameter");
  end:
        
  liste   := float(analysis::nsNewton(f, start, genau));
        
  if ber = FAIL then
    bereich := min(op(liste))..max(op(liste));
  else
    bereich := ber;
  end:

  tangenten   := [ analysis::tangente(f, liste[i]) $ i = 1..nops(liste) ];
  hilfslinien := [plot::Line2d( [liste[i], 0],
                               [liste[i], float(f(liste[i]))],
                               hold(Color) = analysis::_HILFSFARBE)
                  $ i = 1..nops(liste)];

  temp := analysis::_GRID;
  sysassign( analysis::_GRID, 2 );
  tangenten := map(tangenten, analysis::graph, bereich,
                   hold(Color) = analysis::_HILFSFARBE);
  sysassign( analysis::_GRID, temp );
  return( plot::Group2d
         ( op(tangenten),
          analysis::graph(f, bereich,
                          hold(Color) = analysis::_GRAPHFARBE,
// gefaellt mir nicht: (Stefan)                          
//                          hold(TitlePosition) = [0.0, 0.0],
                          hold(Title) = "Numerisch: ".
                          expr2text(liste[nops(liste)])
                          )
          )
         );
    end:

