alias ( FunkTerm(f)     = op(f,1) ):
alias ( FunkVar(f)      = op(f,2) ):

analysis::ableitung := proc(term)
    local leiteab, analyse, x;
begin
    analyse:= proc(ex)
    begin
        if domtype(ex) = DOM_EXPR then 
            // beliebiger Ausdruck
            case type(ex)
                of "_plus" do
                    return("summe");
                break
                of "_mult" do
                    return("mult");
                break
                of "function" do
                    case op(ex, 0)
                        of hold(f) do
                        otherwise
                    end_case
                of "_power" do
                        return("power");
                break
                otherwise
                return("Verkettung");
            end_case
        else // normaler Datentyp
            case domtype(ex)
                of DOM_INT do
                of DOM_RAT do
                    return("zahl");
                of DOM_COMPLEX do
                of DOM_IDENT do
                    return("ident");
                otherwise
                // alles andere
            end_case
        end_if
    end_proc:

    leiteab:= proc(ex, x)
        local summe, summanden, temp2, temp, regel, summand, erg, innen, 
              aussen, innenAbl, aussenAbl, i, u, v, z, uStrich, vStrich, testType, 
              tempList, globalList;
    begin
        globalList:= [];

        temp  := [];
        temp2 := [];
        if type(ex) = "_power" then
            if contains(indets(op(ex, 2)), x) then
                ex := exp(op(ex, 2) * ln(op(ex, 1)));
           end:
        end:
        erg := 0;
        testType := analyse(ex);
        if testType = "summe" then
            summanden := nops(ex);
            if summanden < 4 then
                regel := "(f";
                for i from 1 to summanden-1 do
                    regel := regel.expr2text(i)." + f";
               end:
                regel := regel.expr2text(summanden).")' = ";
                for i from 1 to summanden-1 do
                    regel := regel."f".expr2text(i)."' + ";
               end:
                regel := regel."f".expr2text(summanden)."'";
            else
                regel := "(f1 + f2 + ... + f".expr2text(summanden).")' = f1' + f2' + ... + f".expr2text(summanden)."'";
            end:
            summe := [];
            for i from 1 to nops(ex) do
                summand := diff(op(ex,i),x); 
                temp := append(temp, [op(ex,i), expr2text(op(ex,i))."' = ".expr2text(summand)]);
                summe := append(summe, hold(diff)(op(ex,i),x) );
            end_for;
            erg := hold(_plus)(op(summe));
            temp := append(temp, [erg, "Endergebnis"]);
            tempList := [hold(diff)(ex), ["Summenregel", regel, op(temp)]];
            globalList := globalList.tempList;
        elif testType = "mult" and denom(ex) = 1 then
            regel := "(u * v)' = u'v + v'u";            
            u := op(ex, 1);
            v := _mult(op(ex, 2..nops(ex)));
            uStrich := diff(u, x);
            vStrich := diff(v, x);
            temp := append(temp, 
                [u, " = u, u' = ". expr2text(uStrich) ],
                [v, " = v, v' = ". expr2text(vStrich) ]  
           );
                                                
            erg := hold(_plus)(hold(_mult)(hold(diff)(u, x), v), hold(_mult)(hold(diff)(v, x), u));
            temp := append(temp, [erg, "Endergebnis"]);
            tempList := [hold(diff)(ex), ["Produktregel", regel, op(temp)]];
            globalList := globalList.tempList;
        elif testType = "mult" then
            regel := "(u/v)' = (u'v - v'u)/(v^2)";
            u := numer(ex);
            v := denom(ex);
            uStrich := diff(u, x);
            vStrich := diff(v, x);
            temp := append(temp, [ u, "= u, u' = ". expr2text(uStrich) ],
                                 [ v, " = v, v' = ".expr2text(vStrich) ]
            );
            erg := hold(_divide)(hold(_subtract)
                         (hold(_mult)(hold(diff)(u, x), v), 
                         hold(_mult)(hold(diff)(v, x), u)), v^2
                   );

            temp := append(temp, [erg, "Endergebnis"]);
            tempList := [hold(diff)(ex), ["Quotientenregel", regel, op(temp)]];
            globalList := globalList.tempList;
        else
            regel := "(f(g))' = f'(g) * g'";
            z := genident("z");
           // assume(z,Type::Real);

            temp      := ex;
            innen     := op(temp, 1);
            aussen    := subs(temp, innen = z);
            aussenAbl := diff(aussen, z);
            temp      := aussenAbl;
            aussenAbl := subs(aussenAbl, z = innen);
            innenAbl  := diff(innen, x);
            temp2 := append(temp2, 
              [ {aussen, z = innen}, ["aeusserer Term (f)", 
              [ temp, "aeussere Ableitung, mit ".expr2text(z)." = ".
                expr2text(innen),"ergibt nach Resubst: ". expr2text(aussenAbl)] ]],
              [ innen, ["innerer Term (g), ".expr2text(innen)."' = ".expr2text(innenAbl)]]);

            erg := hold(_mult)(hold(subs)(hold(diff)(aussen, z), z = innen), hold(diff)(innen, x));
            temp2 := append(temp2, [erg, "Endergebnis"]);
            tempList := [hold(diff)(ex), ["Kettenregel", regel, op(temp2)]];
            globalList := globalList.tempList;
        end_if;
        return((adt::Tree(globalList)));
    end_proc:

    if args(0) <> 1 then 
        error("Erwarte genau ein Argument")
    elif domtype(term) = analysis::Funktion then
        x:= op(term,2); term:= op(term,1)
    else
        x:= indets(term);
        if nops(x) <> 1 then error("Term muss genau eine Unbestimmte enthalten") end_if;
        x:= op(x,1)
    end_if;

    return( leiteab(term, x) )
end_proc:

analysis::knoten := proc(tree)
                      local i;
begin
    if args(0) <> 1 or domtype(tree) <> DOM_DOMAIN then
        error("Erwarte ein Objekt, das mit adt::Tree erzeugt worden ist")
    elif tree::nops() > 1 then
        return([([tree::op()][i])::op(0) $ i = 1..(tree::nops())]):
    else
        return([(tree::op(1))::op(0)].([([(tree::op())::op()][i])::op(0) $ i = 2..((tree::op(1))::nops())])):
    end_if;
end_proc:

