alias (zuFolgen = analysis::zuFolgen):
alias (FunkTerm(f) = op(f,1)):
alias (FunkVar(f) = op(f,2)):

//****************************** Analyzer *******************************************/
analysis::lim := proc(f, richtung)
    begin
        f := op(zuFolgen(f));

        if domtype(f) = analysis::Folge then
            return(analysis::Folge::lim( args() ))
        else
            error("Erwarte eine Folge")
        end:
    end_proc:

analysis::differenzenQuotient := proc(f, s, ho)
    local ergebnis;
    begin
        if args(0) < 3 then error("Erwarte mindestens drei Parameter") end:

        s   := analysis::deEqualize(s); 
        ho := analysis::deEqualize(ho);
        
        if not testtype(s, Type::Arithmetical) then
            error("Erwarte einen Term vom Typ 'Type::Arithmetical' als 2. Parameter");
        end:
        if not testtype(ho, Type::Arithmetical) then
            error("Erwarte einen Term vom Typ 'Type::Arithmetical' als 3. Parameter");
        end:

        f := op(analysis::zuFunktionen(f));

        if nops([f]) <> 1 or domtype(f) <> analysis::Funktion then
            error("Erwarte eine Funktion als 1. Parameter");
        end:

        ergebnis := (eval(subs(FunkTerm(f), FunkVar(f) = ho + s)) - eval(subs(FunkTerm(f), FunkVar(f) = s)))/ho;

        return(ergebnis);
    end_proc:
