analysis::monotonie := proc(f, bereich, genau = 1.0/10.0)
    local mitte, i, ergebnis, fstrich, nullstellen, intervalle;
    begin
        if args(0) < 2 then
           error("Erwarte mindestens 2 Parameter")
        end:

        f := op(analysis::zuFunktionen(f));

        if nops([f]) <> 1 or domtype(f) <> analysis::Funktion then
            error("Erwarte eine Funktion als 1. Parameter")
        end:
        if nops(indets(op(f,1)) minus {op(f,2)}) > 1 then 
            error("Funktionsterm enthaelt zu viele Unbestimmte");
        end:
        
        bereich := analysis::deEqualize(bereich):
        genau   := float(analysis::deEqualize(genau));

        if type(bereich) <> "_range" then
            error("Erwarte eine Gleichung als 2. Parameter");
        end:

        if domtype(genau) <> DOM_FLOAT then
            error("Erwarte einen numerischen Wert als 3. Parameter");
        end:        
        
        ergebnis := [];
        fstrich := diff(f);

        nullstellen := analysis::findZerosInRange(fstrich, bereich, genau);
        intervalle  := analysis::zerlegeIntervs(nullstellen, bereich);

        if intervalle = [] then
            intervalle := [op(bereich, 1)..op(bereich, 2)];
        end_if:
        for i from 1 to nops(intervalle) do
            mitte := float((op(intervalle[i], 1) + op(intervalle[i], 2)) / 2); 
            if float(fstrich(mitte)) > 0.0 then
                ergebnis := append(ergebnis, [("_steigend",(intervalle[i]))]);
            elif float(fstrich(mitte)) < 0.0 then
                ergebnis := append(ergebnis, [("_fallend",(intervalle[i]))]);
            else
                mitte := float(op(intervalle[i], 1)):
                while float(fstrich(mitte)) = 0.0 and mitte < float(op(intervalle[i], 2)) do
                    mitte := mitte + genau;
                end_while:

                if float(fstrich(mitte)) > 0.0 then
                    ergebnis := append(ergebnis, [("_steigend",(intervalle[i]))]);
                elif float(fstrich(mitte)) < 0.0 then
                    ergebnis := append(ergebnis, [("_fallend",(intervalle[i]))]);
                else
                    ergebnis := append(ergebnis, [("SO nicht entscheidbar auf: ",(intervalle[i]))]);
                end_if:
            end_if: 
        end_for:
        return(ergebnis);
    end_proc:
