// ueberarbeitet: frankp, 22.03.2000

/*
    wertetabelle( f <,x> s1 <,s2,...> )

    f          : Funktion oder arithm. Ausdruck
    x          : DOM_IDENT
    s1, s2, ...: Type::Real, Bereich Type::Real..Type::Real oder eine
                 Liste [Bereich,Schrittweite]
*/
analysis::wertetabelle := proc()
    local a, f, compute;
begin
    if args(0) < 2  then
        error("Erwarte mindestens zwei Parameter")
    end_if;

    a:= [args()];
    f:= a[1];
    case domtype(f)
    of analysis::Funktion do
    of analysis::Folge do
    of analysis::zusFunktion do
        if nops(a) = 2 and domtype(a[2]) = DOM_IDENT then
            if a[2] <> op(f,2) then
                error("Variablen stimmen nicht ueberein")
            else
                delete a[2]
            end_if
        end_if;
        break
    otherwise
        if domtype(a[2]) = DOM_IDENT then
            if nops(a) = 2 then
                error("Angabe der Stuetzstellen fehlt")
            else
                f:= analysis::Funktion( a[2],f );
                delete a[2]
            end_if
        else
            f := op(analysis::zuFunktionen(f));
            if op(f) = FAIL then    
                error("Ungueltiger 1. Parameter")
            end_if
        end_if
    end_case;

    compute := proc(x)
        local i, y, s;
    begin
        if testtype(x, Type::Numeric) and domtype(x) <> DOM_COMPLEX then
            return( [[x, f(x)]] )
        elif domtype(x) = DOM_LIST then 
            case nops(x)
            of 0 do
                error("Ungueltiges Argument")
            of 1 do
                x:= op(x,1);
                s:= 1;
                break
            of 2 do
                s:= op(x,2);
                if not testtype(s,Type::Real) then
                    error("Schrittweite muss eine reellwertige Konstante sein")
                else
                    x:= op(x,1);
                    break
                end_if
            otherwise
                error("Erwarte Liste der Form [stelle,schrittweite]")
            end_case
        else
            s:= 1
        end_if;
        x:= analysis::deEqualize(x);
        if not testtype(x,Type::Real..Type::Real) then
            error("Die Liste enthaelt ungueltige Eintraege")
        else
            y:= [];
            for i from op(x,1) to op(x,2) step s do
                y := append(y, [i, f(i)])
            end_for;
            return( y )
        end_if
    end_proc:

    delete a[1];
    return( map(a, op@compute) )
end_proc:

